# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from stark_ros_msgs/TensorAxis.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

from ._NDArray import *

class TensorAxis(genpy.Message):
  _md5sum = "da22486f33e5234b4f37773130b6f2f2"
  _type = "stark_ros_msgs/TensorAxis"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# axis name
string name

# Centers along axis (required)
stark_ros_msgs/NDArray centers

# Edges around centers (optional)
stark_ros_msgs/NDArray edges

================================================================================
MSG: stark_ros_msgs/NDArray
# Packed, single dtype Numpy array

# dtype from enumeration in DTypes.msg
uint8 dtype

# Array shape
uint64[] shape

# Row(C)/Column(Fortran) major (off by default)
# https://en.wikipedia.org/wiki/Row-_and_column-major_order
bool is_column_major

# Is the data blob bigendian? (off by default)
bool is_bigendian

# Array data
uint8[] data
"""
  __slots__ = ['name','centers','edges']
  _slot_types = ['string','stark_ros_msgs/NDArray','stark_ros_msgs/NDArray']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       name,centers,edges

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(TensorAxis, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.name is None:
        self.name = ''
      if self.centers is None:
        self.centers = NDArray()
      if self.edges is None:
        self.edges = NDArray()
    else:
      self.name = ''
      self.centers = NDArray()
      self.edges = NDArray()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.centers.dtype
      buff.write(_get_struct_B().pack(_x))
      length = len(self.centers.shape)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(struct.Struct(pattern).pack(*self.centers.shape))
      _x = self
      buff.write(_get_struct_2B().pack(_x.centers.is_column_major, _x.centers.is_bigendian))
      _x = self.centers.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.edges.dtype
      buff.write(_get_struct_B().pack(_x))
      length = len(self.edges.shape)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(struct.Struct(pattern).pack(*self.edges.shape))
      _x = self
      buff.write(_get_struct_2B().pack(_x.edges.is_column_major, _x.edges.is_bigendian))
      _x = self.edges.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.centers is None:
        self.centers = NDArray()
      if self.edges is None:
        self.edges = NDArray()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      start = end
      end += 1
      (self.centers.dtype,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.centers.shape = s.unpack(str[start:end])
      _x = self
      start = end
      end += 2
      (_x.centers.is_column_major, _x.centers.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
      self.centers.is_column_major = bool(self.centers.is_column_major)
      self.centers.is_bigendian = bool(self.centers.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.centers.data = str[start:end]
      start = end
      end += 1
      (self.edges.dtype,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.edges.shape = s.unpack(str[start:end])
      _x = self
      start = end
      end += 2
      (_x.edges.is_column_major, _x.edges.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
      self.edges.is_column_major = bool(self.edges.is_column_major)
      self.edges.is_bigendian = bool(self.edges.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.edges.data = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.centers.dtype
      buff.write(_get_struct_B().pack(_x))
      length = len(self.centers.shape)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(self.centers.shape.tostring())
      _x = self
      buff.write(_get_struct_2B().pack(_x.centers.is_column_major, _x.centers.is_bigendian))
      _x = self.centers.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.edges.dtype
      buff.write(_get_struct_B().pack(_x))
      length = len(self.edges.shape)
      buff.write(_struct_I.pack(length))
      pattern = '<%sQ'%length
      buff.write(self.edges.shape.tostring())
      _x = self
      buff.write(_get_struct_2B().pack(_x.edges.is_column_major, _x.edges.is_bigendian))
      _x = self.edges.data
      length = len(_x)
      # - if encoded as a list instead, serialize as bytes instead of string
      if type(_x) in [list, tuple]:
        buff.write(struct.Struct('<I%sB'%length).pack(length, *_x))
      else:
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.centers is None:
        self.centers = NDArray()
      if self.edges is None:
        self.edges = NDArray()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      start = end
      end += 1
      (self.centers.dtype,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.centers.shape = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
      _x = self
      start = end
      end += 2
      (_x.centers.is_column_major, _x.centers.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
      self.centers.is_column_major = bool(self.centers.is_column_major)
      self.centers.is_bigendian = bool(self.centers.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.centers.data = str[start:end]
      start = end
      end += 1
      (self.edges.dtype,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sQ'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.edges.shape = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
      _x = self
      start = end
      end += 2
      (_x.edges.is_column_major, _x.edges.is_bigendian,) = _get_struct_2B().unpack(str[start:end])
      self.edges.is_column_major = bool(self.edges.is_column_major)
      self.edges.is_bigendian = bool(self.edges.is_bigendian)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.edges.data = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
